Index: src/org/opencms/workplace/CmsWidgetDialog.java
===================================================================
RCS file: /usr/local/cvs/opencms/src/org/opencms/workplace/CmsWidgetDialog.java,v
retrieving revision 1.71
diff -u -r1.71 CmsWidgetDialog.java
--- src/org/opencms/workplace/CmsWidgetDialog.java	8 Sep 2009 14:46:52 -0000	1.71
+++ src/org/opencms/workplace/CmsWidgetDialog.java	14 Jan 2010 17:50:14 -0000
@@ -238,7 +238,7 @@
             href.append(elementName);
             href.append("', ");
             href.append(insertAfter);
-            href.append(");");
+            href.append(",[]);");
             return button(href.toString(), null, "new.png", Messages.GUI_DIALOG_BUTTON_ADDNEW_0, 0);
         } else {
             return "";
Index: src/org/opencms/workplace/CmsWorkplace.java
===================================================================
RCS file: /usr/local/cvs/opencms/src/org/opencms/workplace/CmsWorkplace.java,v
retrieving revision 1.179
diff -u -r1.179 CmsWorkplace.java
--- src/org/opencms/workplace/CmsWorkplace.java	1 Sep 2009 10:03:44 -0000	1.179
+++ src/org/opencms/workplace/CmsWorkplace.java	14 Jan 2010 17:50:14 -0000
@@ -748,7 +748,7 @@
 
         String anchorStart = "<a href=\"";
         if ((href != null) && href.toLowerCase().startsWith("javascript:")) {
-            anchorStart = "<a href=\"#\" onclick=\"";
+            anchorStart = "<a href=\"javascript:;\" onclick=\""; //use "javascript:;" instead of "#" => don't jump to the Top of the page.
         }
 
         result.append("<td style=\"vertical-align: top;\">");
Index: src/org/opencms/xml/CmsXmlContentDefinition.java
===================================================================
RCS file: /usr/local/cvs/opencms/src/org/opencms/xml/CmsXmlContentDefinition.java,v
retrieving revision 1.46
diff -u -r1.46 CmsXmlContentDefinition.java
--- src/org/opencms/xml/CmsXmlContentDefinition.java	21 Aug 2009 15:09:43 -0000	1.46
+++ src/org/opencms/xml/CmsXmlContentDefinition.java	14 Jan 2010 17:50:14 -0000
@@ -146,6 +146,9 @@
     /** Constant for the "sequence" node in the XML schema namespace. */
     public static final QName XSD_NODE_SEQUENCE = QName.get("sequence", XSD_NAMESPACE);
 
+    /** Constant for the "choice" node in the XML schema namespace. */
+    public static final QName XSD_NODE_CHOICE = QName.get("choice", XSD_NAMESPACE);
+    
     /** The XML content handler. */
     private I_CmsXmlContentHandler m_contentHandler;
 
@@ -158,6 +161,9 @@
     /** The outer element name of the content definition (language sequence). */
     private String m_outerName;
 
+    /** Returns true if this sequence is created from a {@link #XSD_NODE_CHOICE}-Element. */
+    private boolean m_isChoiceSequence;
+
     /** The location from which the XML schema was read (XML system id). */
     private String m_schemaLocation;
 
@@ -523,15 +529,21 @@
             // no error: then the language attribute is valid
             hasLanguageAttribute = true;
         }
-
+        
+        boolean isChoice = false;
+        
         // check the main element type sequence
         Element typeSequence = mainElements.get(0);
         if (!XSD_NODE_SEQUENCE.equals(typeSequence.getQName())) {
+            if (!XSD_NODE_CHOICE.equals(typeSequence.getQName())) {
             throw new CmsXmlException(Messages.get().container(
                 Messages.ERR_CD_ELEMENT_NAME_3,
                 typeSequence.getUniquePath(),
                 XSD_NODE_SEQUENCE.getQualifiedName(),
                 typeSequence.getQName().getQualifiedName()));
+            } else {
+                isChoice = true;
+            }
         }
 
         // check the type definition sequence
@@ -553,7 +565,7 @@
             CmsXmlContentTypeManager typeManager = OpenCms.getXmlContentTypeManager();
             Iterator<Element> i = typeSequenceElements.iterator();
             while (i.hasNext()) {
-                sequence.add(typeManager.getContentType(i.next(), includes));
+                sequence.add(typeManager.getContentType((Element)i.next(), includes, isChoice));
             }
         } else {
             // generate a nested content definition for the main type sequence
@@ -569,7 +581,7 @@
         }
 
         // return a data structure with the collected values
-        return new CmsXmlComplexTypeSequence(name, sequence, hasLanguageAttribute);
+        return new CmsXmlComplexTypeSequence(name, sequence, hasLanguageAttribute, isChoice);
     }
 
     /**
@@ -704,8 +716,8 @@
         result.setInnerName(outer.getName());
 
         // get the inner element sequence, this must be the second element 
-        CmsXmlComplexTypeSequence innerSequence = complexTypeData.get(1);
-
+        CmsXmlComplexTypeSequence innerSequence = (CmsXmlComplexTypeSequence)complexTypeData.get(1);
+        result.m_isChoiceSequence =innerSequence.m_isChoiceSequence;
         // add the types from the main sequence node
         Iterator<I_CmsXmlSchemaType> it = innerSequence.getSequence().iterator();
         while (it.hasNext()) {
@@ -852,6 +864,7 @@
         result.m_contentHandler = m_contentHandler;
         result.m_typeName = m_typeName;
         result.m_includes = m_includes;
+        result.m_isChoiceSequence = m_isChoiceSequence;
         return result;
     }
 
@@ -1174,4 +1187,16 @@
 
         m_outerName = outerName;
     }
+    
+
+    /**
+     * Returns <code>true</code> if this sequence is created from a {@link #XSD_NODE_CHOICE}-Element. 
+     * 
+     * @return <code>true</code> if this sequence is created from a {@link #XSD_NODE_CHOICE}-Element. 
+     * 
+     * @see CmsXmlNestedContentDefinition
+     */
+    public boolean isChoiceType() {
+        return m_isChoiceSequence;
+    }
 }
\ No newline at end of file
Index: src/org/opencms/xml/CmsXmlComplexTypeSequence.java
===================================================================
RCS file: /usr/local/cvs/opencms/src/org/opencms/xml/CmsXmlComplexTypeSequence.java,v
retrieving revision 1.7
diff -u -r1.7 CmsXmlComplexTypeSequence.java
--- src/org/opencms/xml/CmsXmlComplexTypeSequence.java	21 Aug 2009 15:09:43 -0000	1.7
+++ src/org/opencms/xml/CmsXmlComplexTypeSequence.java	14 Jan 2010 17:50:14 -0000
@@ -55,18 +55,23 @@
     /** The type sequence elements. */
     private List<I_CmsXmlSchemaType> m_sequence;
 
+    /** Returns true if this sequence is created from a {@link CmsXmlContentDefinition#XSD_NODE_CHOICE}-Element. */
+    protected boolean m_isChoiceSequence;
+
     /**
      * Creates a new complex type sequence data structure.<p>
      * 
      * @param name the name of the sequence
      * @param sequence the type sequence element list
      * @param hasLanguageAttribute indicates if a "language" attribute is present
+     * @param isChoiceSequence the type choice element list
      */
-    protected CmsXmlComplexTypeSequence(String name, List<I_CmsXmlSchemaType> sequence, boolean hasLanguageAttribute) {
+    protected CmsXmlComplexTypeSequence(String name, List sequence, boolean hasLanguageAttribute, boolean isChoiceSequence) {
 
         m_name = name;
         m_sequence = sequence;
         m_hasLanguageAttribute = hasLanguageAttribute;
+        m_isChoiceSequence = isChoiceSequence;
     }
 
     /**
Index: src/org/opencms/xml/CmsXmlContentTypeManager.java
===================================================================
RCS file: /usr/local/cvs/opencms/src/org/opencms/xml/CmsXmlContentTypeManager.java,v
retrieving revision 1.38
diff -u -r1.38 CmsXmlContentTypeManager.java
--- src/org/opencms/xml/CmsXmlContentTypeManager.java	21 Aug 2009 15:09:43 -0000	1.38
+++ src/org/opencms/xml/CmsXmlContentTypeManager.java	14 Jan 2010 17:50:14 -0000
@@ -324,15 +324,19 @@
      * Generates an initialized instance of a XML content type definition
      * from the given XML schema element.<p>
      * 
-     * @param typeElement the element to generate the XML content type definition from
-     * @param nestedDefinitions the nested (included) XML content sub-definitions
+     * @param typeElement
+     *          The element to generate the XML content type definition from
+     * @param nestedDefinitions
+     *          The nested (included) XML content sub-definitions
+     * @param isChoice
+     *          true if this node is an element of a Choice XSD element.
+     *          In this case the maxOccurs is always handled as "1" and minOccurs is always handled as "0".
      * 
      * @return an initialized instance of a XML content type definition
      * @throws CmsXmlException in case the element does not describe a valid XML content type definition
      */
-    public I_CmsXmlSchemaType getContentType(Element typeElement, Set<CmsXmlContentDefinition> nestedDefinitions)
+    public I_CmsXmlSchemaType getContentType(Element typeElement, Set nestedDefinitions, boolean isChoice)
     throws CmsXmlException {
-
         if (!CmsXmlContentDefinition.XSD_NODE_ELEMENT.equals(typeElement.getQName())) {
             throw new CmsXmlException(Messages.get().container(Messages.ERR_INVALID_CD_SCHEMA_STRUCTURE_0));
         }
@@ -345,7 +349,12 @@
         String defaultValue = typeElement.attributeValue(CmsXmlContentDefinition.XSD_ATTRIBUTE_DEFAULT);
         String maxOccrs = typeElement.attributeValue(CmsXmlContentDefinition.XSD_ATTRIBUTE_MAX_OCCURS);
         String minOccrs = typeElement.attributeValue(CmsXmlContentDefinition.XSD_ATTRIBUTE_MIN_OCCURS);
-
+        // a schemyType inside a Choice-ContentDefinition can only occurred one time.
+        if (isChoice) {
+            minOccrs = CmsXmlContentDefinition.XSD_ATTRIBUTE_VALUE_ZERO;
+            maxOccrs = "1";
+        }
+        
         if (CmsStringUtil.isEmpty(elementName) || CmsStringUtil.isEmpty(typeName)) {
             throw new CmsXmlException(Messages.get().container(Messages.ERR_INVALID_CD_SCHEMA_STRUCTURE_0));
         }
@@ -362,7 +371,14 @@
                 if (typeName.equals(cd.getTypeName())) {
 
                     simpleType = false;
-                    return new CmsXmlNestedContentDefinition(cd, elementName, minOccrs, maxOccrs);
+                    if (cd.isChoiceType()) {
+                        // A Choice Element itself is always optional.
+                        // the initial XML content (create new resource) can not be automatically generated if minOccurs > 0
+                        // the editor must choose the sub element!
+                        return new CmsXmlNestedContentDefinition(cd, elementName, CmsXmlContentDefinition.XSD_ATTRIBUTE_VALUE_ZERO, maxOccrs);
+                    } else {
+                        return new CmsXmlNestedContentDefinition(cd, elementName, minOccrs, maxOccrs);
+                    }
                 }
             }
 
Index: modules/org.opencms.editors/resources/system/workplace/editors/xmlcontent/editor_form.jsp
===================================================================
RCS file: /usr/local/cvs/opencms/modules/org.opencms.editors/resources/system/workplace/editors/xmlcontent/editor_form.jsp,v
retrieving revision 1.15
diff -u -r1.15 editor_form.jsp
--- modules/org.opencms.editors/resources/system/workplace/editors/xmlcontent/editor_form.jsp	9 Jun 2009 12:21:36 -0000	1.15
+++ modules/org.opencms.editors/resources/system/workplace/editors/xmlcontent/editor_form.jsp	14 Jan 2010 17:50:14 -0000
@@ -298,9 +298,42 @@
 //-->
 </script>
 
+<style>
+#CHOICE_OVERLAY
+{
+    display:none;
+    position:absolute;
+    top:0;
+    left:0;
+    z-index:5000;   
+    background-color:#000;
+    -moz-opacity: 0.5;
+    opacity:.50;
+    filter: alpha(opacity=50);
+}
+
+#CHOICE_SELECT{
+    display:none;
+    position: absolute;
+    z-index:9999;
+    background-color:#D4D0C8;
+    border-left:2px solid white;
+    border-top:2px solid white;
+    border-right:2px solid #808080;
+    border-bottom:2px solid #808080;
+}
+
+</style>
+
 </head>
 <body class="buttons-head" unselectable="on" onload="init();" onunload="exitEditor();">
 
+<div id="CHOICE_OVERLAY" name="CHOICE_OVERLAY"></div>
+<div id="CHOICE_SELECT" name="CHOICE_SELECT" >
+  <div style="width:100%;text-align:right;border-bottom:1px solid #000000;" ><a href="javascript:;" onClick="closeChoiceSelection();"><img src="<%=wp.getSkinUri()%>buttons/exit.png" alt="close" width="20" height="20" border="0"/></a></div>
+  <div style="overflow:auto;" id="CHOICE_SELECT_LINKS" name="CHOICE_SELECT_LINKS" ></div>
+</div>
+
 <form name="EDITOR" id="EDITOR" method="post" action="<%= wp.getJsp().link(CmsEditor.PATH_EDITORS + "xmlcontent/editor_form.jsp") %>">
 <input type="hidden" name="<%= CmsDialog.PARAM_ACTION %>" value="<%= wp.getParamAction() %>">
 <input type="hidden" name="<%= CmsDialog.PARAM_RESOURCE %>" value="<%= wp.getParamResource() %>">
@@ -314,6 +347,7 @@
 <input type="hidden" name="<%= CmsEditor.PARAM_MODIFIED %>" value="<%= wp.getParamModified() %>">
 <input type="hidden" name="<%= CmsXmlContentEditor.PARAM_ELEMENTINDEX %>" value="">
 <input type="hidden" name="<%= CmsXmlContentEditor.PARAM_ELEMENTNAME %>" value="">
+<input type="hidden" name="<%= CmsXmlContentEditor.PARAM_CHOICEELEMENTNAME %>" value="">
  
 <%= wp.getXmlEditorForm() %>
 
Index: modules/org.opencms.editors/resources/system/workplace/editors/xmlcontent/edit.js
===================================================================
RCS file: /usr/local/cvs/opencms/modules/org.opencms.editors/resources/system/workplace/editors/xmlcontent/edit.js,v
retrieving revision 1.15
diff -u -r1.15 edit.js
--- modules/org.opencms.editors/resources/system/workplace/editors/xmlcontent/edit.js	4 Jun 2009 14:39:11 -0000	1.15
+++ modules/org.opencms.editors/resources/system/workplace/editors/xmlcontent/edit.js	14 Jan 2010 17:50:14 -0000
@@ -190,14 +190,88 @@
 }
 
 // add an optional element to the currently edited content
-function addElement(elemName, insertAfter) {
+function addElement(elemName, insertAfter, choiceList) {
 	setLastPosition();
 	var _form = document.EDITOR;
 	_form.elementname.value = elemName;
 	_form.elementindex.value = insertAfter;
+	if (choiceList.length == 0){
+		buttonAction(5);
+	} else if (choiceList.length == 1){
+		addChoiceElement(choiceList[0].Name);
+	} else {
+		// more than one element
+		showChoiceSelection(choiceList);
+	}
+}
+
+function addChoiceElement(elemName) {
+	var _form = document.EDITOR;
+	_form.choiceelementname.value = elemName;
 	buttonAction(5);
 }
 
+// shows the possible SubElements for a Choice-NestedContentType
+function showChoiceSelection(choiceList) {
+
+    // get Choice element
+    var choiceOverlay = document.getElementById("CHOICE_OVERLAY");
+    var choiceSelectElem = document.getElementById("CHOICE_SELECT");
+    var choiceSelectLinksElem = document.getElementById("CHOICE_SELECT_LINKS");
+
+    // create the button row HTML
+    var i = 0;
+    var linkList ="";
+    for (i=0; i < choiceList.length; i++){
+        if (i > 0){
+            linkList += "<br />";
+        }
+        linkList += "<a href=\"javascript:addChoiceElement(&quot;" + choiceList[i].Name + "&quot;);\" >";
+        linkList += choiceList[i].Label;
+        linkList += "</a>";
+        if (choiceList[i].Help){
+	        linkList += " (";
+	        linkList += choiceList[i].Help;
+	        linkList += ")";
+        }
+    }
+
+
+    // set the created HTML into the ModalBox
+    choiceSelectLinksElem.innerHTML = linkList;
+
+    // arrange the Modal-Box
+    var height = document.body.clientHeight/2;
+    var width = document.body.clientWidth/2;
+    choiceSelectElem.style.height = height + 'px';
+    choiceSelectElem.style.width = width + 'px';
+    choiceSelectLinksElem.style.height = height + 'px';
+    choiceSelectLinksElem.style.width = width + 'px';
+	choiceSelectElem.style.top  = document.body.scrollTop+(document.body.clientHeight - height)/2;
+	choiceSelectElem.style.left  = document.body.scrollLeft+(document.body.clientWidth - width)/2;
+
+    // show the Modal-Box
+    choiceSelectElem.style.display = "block";
+
+    // show the Gay Background
+	choiceOverlay.style.height = document.body.scrollHeight + 'px';
+	choiceOverlay.style.width = document.body.scrollWidth + 'px';
+    choiceOverlay.style.display = "block";
+
+}
+
+
+function closeChoiceSelection() {
+	var _form = document.EDITOR;
+	// reset the Data
+	_form.elementname.value = "";
+	_form.elementindex.value = "";
+	_form.choiceelementname.value = "";
+	// close the Modal-Box
+    document.getElementById('CHOICE_SELECT').style.display ='none';
+    document.getElementById('CHOICE_OVERLAY').style.display = 'none';
+}
+
 // move an element in currently edited content
 function moveElement(elemName, index, direction) {
 	setLastPosition();
@@ -307,7 +381,7 @@
 }
 
 // shows the element operation buttons
-function showElementButtons(elementName, elementIndex, showRemove, showUp, showDown, showAdd) {
+function showElementButtons(elementName, elementIndex, showRemove, showUp, showDown, showAdd, choiceList) {
 	var elemId = elementName + "." + elementIndex;
 	if (oldEditorButtons != null && oldEditorButtons != elemId) {
 		// close eventually open element buttons
@@ -342,7 +416,7 @@
 
 	// add element button
 	if (showAdd) {
-		buttons += button("javascript:addElement('" + elementName + "', " + elementIndex + ")", null, "new", LANG_BT_ADD, buttonStyle);
+		buttons += button("javascript:addElement('" + elementName + "', " + elementIndex + ", " + choiceList + ")", null, "new", LANG_BT_ADD, buttonStyle);
 	} else {
 		buttons += button(null, null, "new_in", LANG_BT_ADD, buttonStyle);
 	}
